/*
** definizione e test delle funzioni per l'implementazione
** dell'algoritmo di insertion sort
*/

/*
** inclusione del file di intestazione della libreria standard
** che contiene definizioni di macro, costanti e dichiarazioni
** di funzioni e tipi funzionali alle varie operazioni di I/O
*/
#include <stdio.h>

/* definizione della costante simbolica per la dimensione del vettore */
#define DIM 5

/*
** funzione per l'acquisizione del contenuto di un vettore di interi
*/
void acqVettInt (int *vett, int dim)
 {
 /* variabile per la scansione del vettore */
 int cursore;
 
 /* scandisce il vettore acquisendone gli elementi */
 for (cursore=0; cursore <= dim-1; cursore++)
    {
    printf("\nvett[%d]? ", cursore);
    scanf("%d", &vett[cursore]);
    }
 }
 

/*
** funzione per la restituzionee del contenuto di un vettore di interi
*/
void resVettInt (int *vett, int dim)
 {
 /* variabile per la scansione del vettore */
 int cursore;

 /* scandisce il vettore visualizzandone gli elementi */ 
 for (cursore=0; cursore <= dim-1; cursore++)
	printf("\nvett[%d]: %d", cursore, vett[cursore]);
 }

/*
** definizione di una funzione che scambia il contenuto di due variabili intere
*/
void scambiaInt(int *x, int *y)
   {
   /* definizione di una variabile ausiliaria */
   int aux;   
   
   /* i valori delle due variabili */
   aux = *x;
   *x = *y;
   *y = aux;
   }

/*
** definizione della funzione che calcola
** la posizione del minimo all'interno di
** un vettore di interi
*/
int calcPosMinVettInt (int *vett, int dim)
   {
   /* cursore per la scansione del vettore */
   int cursore;
   
   /* variabile per il minimo corrente */
   int min;
   
   /* variabile per la posizione del minimo corrente */
   int posMin;
   
   /* inizializzazione del minimo corrente e della sua
   ** posizione */
   min = vett[0];
   posMin = 0;
   
   for (cursore = 0; cursore <= dim-1; cursore++)
     /* confronto l'elemento corrente con il minimo corrente
     ** e se necessario aggiorno il valore e la posizione di
	 ** quest'ultimo */
	 if (vett[cursore] < min)
		{
		min = vett[cursore];
		posMin = cursore;
		};
		
   /* al termine della scansione restituisco la posizione del minimo */
   return(posMin);
   }
/*
** definizione della funzione che implementa l'algoritmo di insertion sort
** su un vettore di interi
*/
void insertSortVettInt (int *vett, int dim)
	{
	/* cusore per la scansione del vettore */
	int cursore;
	
	/* definizione della variabile per la posizione del minimo corrente */
	int posMin;
	 
	/* scandisco il vettore dalla prima alla penultima
	** posizione */
	for (cursore = 0; cursore <= dim-2; cursore++)
	   {	   
	   /* calcolo la posizione del minimo */
	   posMin = calcPosMinVettInt (vett+cursore, dim-cursore);
	   
	   /* scambio il contenuto della posizione corrente
	   ** con quello della posizione contenente il minimo */
	   scambiaInt(vett+cursore, vett+cursore+posMin);
	   }
	}
	
/*
** test delle funzioni per l'implementazione
** dell'algoritmo di insertion sort
** 
*/
int main()
	{
	/* testo il corretto funzionamento della funzione che
	** implementa l'insertion sort */
	
	/* definisco un vettore di test */
	int test[DIM];
	
	/* acquisisco il contenuto del vettore di test */
	acqVettInt (test, DIM);
	
	/* ordino il vettore */
	insertSortVettInt (test, DIM);
	
	/* visualizzo il contenuto del vettore successivamente allo scambio */
	resVettInt(test, DIM);
		
	return(1);
	}

